<template>
  <two-panes :leftCaption="dictionaryRu.title">
    <template slot="left">
      <div class="select-currency">
        {{ dictionaryRu.select_currency }}
        <ob-inline-select
          v-model="activeCurrencyCode"
          :items.sync="currencyList"
          display-expr="code"
          value-expr="code"
          placeholder
          class="form-controls ml4"
          @input="loadData"
        />
        {{ dictionaryRu.select_currency_pretext }}
        <ob-date-picker
          format="dd.MM.yyyy"
          placeholder="Выберите дату"
          label="Date"
          :allow-all="true"
          :is-inline="true"
          v-model="activeDate"
          class="ml4"
          @input="loadData"
        />
      </div>
      <ob-table
        :items="dataSource"
        :columns="columnsObTable"
        :functionalPanel="true"
        is-fixed-header
        ref="obTable"
        @select="onSelection"
      />
      <ob-modal
        ref="viewItem"
        :title="dictionaryRu.modal.title"
        :is-show-pagination="true"
        :is-show-controls="false"
        :is-read-only="true"
      >
        <currency :selected-data="selectedData" />
      </ob-modal>
    </template>
    <template slot="right">
      <currency-detail
        v-if="!isEmpty(dynamicsData)"
        :currency="dynamicsData"
        :active-currency="activeCurrencyCode"
        :date="activeDate"
      />
    </template>
  </two-panes>
</template>

<script>
import api                         from '@/api';
import { getCountryFlag, isEmpty } from '@/helpers';
import moment                      from 'moment';
import TwoPanes                    from 'common-components/src/obComponents/obTwoPanels';
import CurrencyDetail              from './CurrencyDetail';
import Currency                    from './modal/Currency';
import ObModal                     from 'common-components/src/obComponents/obModal';
import ObInlineSelect              from 'common-components/src/obComponents/obInlineSelect';
import ObDatePicker                from 'common-components/src/obComponents/obDatePickerConstructor';
import ObTable                     from 'common-components/src/obComponents/obTable';
import { dictionaryDefault }       from '@/translations/ru/default'
import { dictionary }              from '@/translations/ru/dictionaries__common__currencies'

export default {
  name: 'Currencies',
  components: {
    ObModal,
    Currency,
    ObTable,
    TwoPanes,
    CurrencyDetail,
    ObInlineSelect,
    ObDatePicker
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name',
          html: function(data) {
            return `<div class="flex jc-fs al-i-c">
              <img width="22" style="box-shadow: 0 0 2px #dbdbdb" src="${getCountryFlag(
                data.code
              )}" alt="">
              <span class="pl-10">${data.name}</span>
            </div>`;
          }
        },
        {
          title: this.dictionaryRu.columns.code,
          key: 'code'
        },
        {
          title: this.dictionaryRu.columns.numeric_code,
          key: 'numeric_code'
        },
        {
          title: this.dictionaryRu.columns.unicode,
          key: 'unicode'
        },
        {
          title:
            this.dictionaryRu.columns.currency_rate +
            ' ' +
            this.activeCurrencyCode +
            ' ' +
            this.dictionaryRu.columns.currency_rate_pretext +
            ' ' +
            moment(this.activeDate).format('DD.MM.YYYY'),
          key: 'currency_rate',
          html: function(data) {
            return String(data.currency_rate);
          }
        },
        {
          title: this.dictionaryRu.columns.currency_rate_dynamics,
          width: 110,
          key: 'currency_rate_dynamics',
          html: function(data) {
            let color = data.currency_rate_dynamics > 0 ? 'green' : 'red';
            let prefix = data.currency_rate_dynamics > 0 ? '+' : '';
            return (
              '<span class="dynamics-' +
              color +
              '">' +
              prefix +
              data.currency_rate_dynamics +
              '</span>'
            );
          }
        },
        {
          title: '',
          html: function() {
            return '<div class="pencil"></div>';
          },
          action: data => this.viewCurrency(data),
          isToggleDisabled: true
        }
      ];
    }
  },
  mounted() {
    this.loadCurrencyList();
  },
  data() {
    return {
      dataGridRefName: 'Currencies',
      dataSource: [],
      currencyList: [],
      activeCurrencyCode: 'AUD',
      activeDate: new Date(),
      dynamicsData: {},
      selectedData: {},
      disabledDates: value => {
        return new Date() < value.date;
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    };
  },
  methods: {
    isEmpty,
    async loadCurrencyList() {
      try {
        const { data } = await api.general.getCurrencies()
        this.currencyList = data

        if (this.currencyList && this.currencyList.length) {
          this.activeCurrencyCode = this.currencyList[0].code
          this.loadData()
        }
      }
      catch (e) {
        console.error(e)
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки списка валют'
        })
      }
    },
    async loadData() {
      try {
        const { data } = await api.general.getCurrenciesRates(
          this.activeCurrencyCode,
          moment(this.activeDate).format('YYYY-MM-DD')
        )
        this.dataSource = data.currencies
      }
      catch (e) {
        console.error(e)
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки курсов валют'
        })
      }
    },
    async onSelection(data) {
      this.dynamicsData = data;
    },
    async viewCurrency(data) {
      try {
        let _data = await api.general.getCurrenciesDetail(data.currency_uuid);
        this.selectedData = _data.data;
        this.$refs.viewItem.open();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    }
  }
};
</script>

<style lang="scss">
.pencil {
  width: 24px;
  height: 24px;
  cursor: pointer;
}
.select-currency {
  padding: 15px 20px;
  display: flex;
}

.ml4 {
  margin-left: 4px;
}
</style>
